
// using Noritake GU140x32F-7000 Display
// JB 8/5/13 //587 


#include <device.h>              // Setup psoc hardware
#include <stdio.h>               // library for snprintf

                                        // Global variables
int Vrefcount = 0;               // cal vref
int Gndcount = 0;                // cal gnd ref                  
int adcResult = 0;               // adc results count          (will be removed when I figure out passing variable by pointers)                                 
int  avgadcResult = 0;           // average adc results count  (will be removed when I figure out passing variable by pointers)
double ADC_Volts = 0;            // ADC_Volts results          (will be removed when I figure out passing variable by pointers)
double avgADC_Volts = 0;         // average of ADC_Volts       (will be removed when I figure out passing variable by pointers)

                                        // Sets up functions to call
void initialize(void);           // initialize has no variables to initialize

                                 // ADC has a variable passed to it, avgtotake, vrefcount and gndcount. On return, *adc, *avgadc, *volts and *avgvolts are passed 
void ADC(int avgtotake);         // , int gndcount, int vrefcount for when global has been removed                 

                                 // Display has variables passed to it, sps_rate, avgtotake, adc, avgadc, volts and avgvolts
void Display(int avgtotake, int sps_rate,int over_under, int adc, int avgadc, double volts, double avgvolts); 
void Cal();                      // Calibrates ADC's offsets by messuring ground and vref. On return, vrefcount and gndcount are passed


void main()                             // Program flow control loop and data exchange
{
                                        // Local variables
int calcount = 0;                // counts the number of normal smapling before doing an offset cal
int avgtotake = 35;              // Number of averages to take, passed to ADC function, range 1 to 99 (The display is limited to two places for this variable)
int sps_rate = 187;              // Number of samples per second ADC has been set too, passed to Display, Range ADC lowest setting to 999 (The display is limited to three places for this variable)
//int vrefcount = 0;               // ADC count result from measuring vref (using global for now)
//int gndcount = 0;                // ADC count result from measuring gnd  (using global for now)
int adc = 0;                     // adc results count
int avgadc =0;                   // average adc results count
double volts = 0;                // ADC_Volts results
double avgvolts = 0;             // average of ADC_Volts
int over_under = 0;              // Flag for input being over vref or under gnd


                                        // One time call to setup hardware
initialize();                    // initialize UART, ADC and DISPLAY
                                        //
    for(;;){                                   // Loop forever, calling ADC then Display
        for (calcount=0; calcount < 100; calcount++){ 
        
                                 // Number of readings to take, used to averages results
ADC(avgtotake);                  // , int gndcount, int vrefcount for when global has been removed

                                 // Formats results and passes them out to display, with handshaking
Display(avgtotake, sps_rate, over_under, adc, avgadc, volts, avgvolts); 

        }                        // Loop back ADC, Display
Cal();                           // cals offsets
    }   // Loop back Cal              
} //end main
                                            
    
   void initialize()
{
UART_1_Start();		                           // initialize UART
UART_1_PutChar(0x1b); UART_1_PutChar(0x40);    // initialize VFD
UART_1_PutChar(0x0c);                          // ClearDisplay
UART_1_PutChar(0x1f); UART_1_PutChar(0x58);    // Command VFD Brightness level
UART_1_PutChar(0x01);                          // Set brightness level, 1=12.5%, 2=25%, 3=37.5%, 4=50%, 5=62.5%, 6=75%, 7=87.5%, 8=100%
AMuxSeq_1_Start();                             // start multiplexer sequencer
AMuxSeq_1_Next();                              // set to channel 0
ADC_DelSig_1_Start();				           // start the ADC_DelSig_1
ADC_DelSig_1_StartConvert();		           // start the ADC_DelSig_1 conversion
Cal();                                         // get calibration factors before taking any reading
}       // end initialize


void ADC(int avgtotake)          // , int gndcount, int vrefcount for when global has been removed
{
                                        // Local variables
int avgcount = 0;                // loop counter for average                                        
avgadcResult=0;                  // clear average for new adc count average
avgADC_Volts=0;                  // clear average for new volts average

    for (avgcount=0; avgcount < avgtotake; avgcount++){  // loop for average results
        if (ADC_DelSig_1_IsEndConversion(ADC_DelSig_1_WAIT_FOR_RESULT)){}  // function to wait for adc to be ready
        
    adcResult = ADC_DelSig_1_GetResult32();	   // read the adc and assign the value adcResult 
    adcResult=adcResult-Gndcount;
    ADC_Volts = adcResult*(1.024/Vrefcount);   // convert count to microvolts
    avgadcResult+=adcResult;                   // add up adc count as many times as average loop is set for
    avgADC_Volts+=ADC_Volts;                   // add up volts as many times as average loop is set for
    }

avgadcResult=avgadcResult/avgtotake;     // divide results by average to take
avgADC_Volts=avgADC_Volts/avgtotake;     // divide results by average to take 

return; // Return to caller; On return, *adc, *avgadc, *volts, *avgvolts and *overunder are passed
}       // end ADC

                                // **** Displays results ****
void Display(int avgtotake, int sps_rate, int over_under, int adc, int avgadc, double volts, double avgvolts) 
{
                                        // Local variables
char DisCharStr [21]="";        // length of temp string to hold formatted results for display (set to one line of text)
int  BSCount = 1;               // keeps track of how many back spaces have been sent to display

                                        // Output line one
    snprintf (DisCharStr, 21, "ADC:%07d:%1.5fV", adcResult, ADC_Volts);           // Format results for display (max 20 Char)
    UART_1_PutString(DisCharStr);                                                 // Display results (one line, 20 Chars long max)

                                        // Output line two
    snprintf (DisCharStr, 21, "average:%2dR @ %2dSps",avgtotake,sps_rate);        // Format results for display (max 20 Char)
    UART_1_PutString(DisCharStr);                                                 // Display results (one line, 20 Chars long max)

                                        // Output line three
    snprintf (DisCharStr, 21, "ADC:%07d:%1.5fV", avgadcResult, avgADC_Volts);     // Format results for display (max 20 Char)
    UART_1_PutString(DisCharStr);                                                 // Display results (one line, 20 Chars long max)

                                       // Output line four
    snprintf (DisCharStr, 21, "Display Rate %03dRps", sps_rate/avgtotake);        // Format results for display (max 20 Char)
    UART_1_PutString(DisCharStr);                                                 // Display results (one line, 20 Chars long max)

                                        // Home display loop
        for (BSCount=1; BSCount <= 80; BSCount++){ UART_1_PutChar(0x08);          // backspace display to home, results are over written so dislay does not flicker
        }

}       // end Display


void Cal()
{
                                        // Local variables
//                            **************** for testing only, to be removed ********************
int time = 0;
int count = 0;
int caltime = 0;
//                            **************** for testing only, to be removed ********************

//int vrefcount = 0;            // using global for now
//int gndcount = 0;             // using global for now
char DisCharStr [21]="";        // length of temp string to hold formatted results for display (set to one line of text)
int  BSCount = 1;               // keeps track of how many back spaces have been sent to display

//                            **************** for testing only, to be removed ********************
for (caltime=1; caltime <= 90; caltime++){
//                            **************** for testing only, to be removed ********************

AMuxSeq_1_Next(); // set to channel 1 vref
for (time=0; time <= 3; time++){
if (ADC_DelSig_1_IsEndConversion(ADC_DelSig_1_WAIT_FOR_RESULT)){}  // function to wait for adc to be readyvrefcount = ADC_DelSig_1_GetResult32();
Vrefcount = ADC_DelSig_1_GetResult32();
}

AMuxSeq_1_Next(); // set to channel 2 gnd
for (time=0; time <= 2; time++){
if (ADC_DelSig_1_IsEndConversion(ADC_DelSig_1_WAIT_FOR_RESULT)){}  // function to wait for adc to be ready
Gndcount = ADC_DelSig_1_GetResult32();
}

AMuxSeq_1_Next(); // set to channel 0 ext

//                            **************** for testing only, to be removed ********************
for (time=0; time <= 2; time++){
if (ADC_DelSig_1_IsEndConversion(ADC_DelSig_1_WAIT_FOR_RESULT)){} // function to wait for adc to be ready
count = ADC_DelSig_1_GetResult32();
}
//                            **************** for testing only, to be removed ********************


//                            **************** for testing only, to be removed ********************
    snprintf (DisCharStr, 21, "CAL vref :   %07d", Vrefcount);                    // Format results for display (max 20 Char)
    UART_1_PutString(DisCharStr);                                                 // Display results (one line, 20 Chars long max)
    snprintf (DisCharStr, 21, "CAL gnd  :   %07d", Gndcount);                     // Format results for display (max 20 Char)
    UART_1_PutString(DisCharStr);                                                 // Display results (one line, 20 Chars long max)
    snprintf (DisCharStr, 21, "CAL in   :   %07d", count-Gndcount);                        // Format results for display (max 20 Char)
    UART_1_PutString(DisCharStr);                                                 // Display results (one line, 20 Chars long max)
    snprintf (DisCharStr, 21, "CAL Time :   %07d", caltime);                      // Format results for display (max 20 Char)
    UART_1_PutString(DisCharStr);                                                 // Display results (one line, 20 Chars long max)
                                        // Home display loop
        for (BSCount=1; BSCount <= 61; BSCount++){ UART_1_PutChar(0x08); }        // backspace display to home, results are over written so dislay does not flicker
        }
//                            **************** for testing only, to be removed ********************

return; // Return to caller; On return, *vrefcount and *gndcount  are passed
}

/* [] END OF FILE */